#include "stdafx.h"

#include "PhoneLibUtil.h"


/* Defines */
#define SHPHONELIBDLL			_T("shphonelib.dll")
#define CSHPHONELIB_CTOR		_T("??0Cshphonelib@@QAA@PAUHWND__@@@Z")
#define CSHPHONELIB_DTOR		_T("??1Cshphonelib@@QAA@XZ")
#define CSHPHONELIB_ONHOOK		_T("?OnHook@Cshphonelib@@QAAXXZ")

SHPHONELIBIF*
CreateShPhoneLibIF()
{
	BOOL						bSucc = FALSE;
	HMODULE						hModule = NULL;
	PFNCSHPHONELIB_CTOR			pfnCshphonelib_Ctor = NULL;
	PFNCSHPHONELIB_DTOR			pfnCshphonelib_Dtor = NULL;
	PFNCSHPHONELIB_ONHOOK		pfnCshphonelib_OnHook = NULL;
	LPBYTE						pInstance = NULL;
	SHPHONELIBIF*				pLibIF = NULL;

	
	hModule = LoadLibrary(SHPHONELIBDLL);
	if (hModule != NULL) {
		pfnCshphonelib_Ctor = (PFNCSHPHONELIB_CTOR) GetProcAddress(hModule, CSHPHONELIB_CTOR);
		pfnCshphonelib_Dtor = (PFNCSHPHONELIB_DTOR) GetProcAddress(hModule, CSHPHONELIB_DTOR);
		pfnCshphonelib_OnHook = (PFNCSHPHONELIB_ONHOOK) GetProcAddress(hModule, CSHPHONELIB_ONHOOK);
		
		if (pfnCshphonelib_Ctor != NULL &&
			pfnCshphonelib_Dtor != NULL &&
			pfnCshphonelib_OnHook != NULL ) {

			pInstance = (LPBYTE) malloc(0x4000);	// CshphonelibNX̃TCY͕sD
													// 16k炢mۂĂD
			if (pInstance != NULL) {
				pLibIF = (SHPHONELIBIF*) malloc(sizeof(SHPHONELIBIF));
				memset(pLibIF, 0, sizeof(SHPHONELIBIF));
				if (pLibIF != NULL) {
					pLibIF->pInstance = pInstance;
					pLibIF->hModule = hModule;
					pLibIF->pfnCshphonelib_Ctor = pfnCshphonelib_Ctor;
					pLibIF->pfnCshphonelib_Dtor = pfnCshphonelib_Dtor;
					pLibIF->pfnCshphonelib_OnHook = pfnCshphonelib_OnHook;

					bSucc = TRUE;
				}
			}
		}
	}

	if (!bSucc) {
		if (pLibIF != NULL) {
			free(pLibIF);
			pLibIF = NULL;
		}
		if (pInstance != NULL) {
			free(pInstance);
			pInstance = NULL;
		}
		if (hModule != NULL) {
			FreeLibrary(hModule);
			hModule = NULL;
		}
	}
	
	return pLibIF;
}

void
DeleteShPhoneLibIF(
	SHPHONELIBIF* pLibIF
)
{
	if (pLibIF != NULL) {
		if (pLibIF->pInstance != NULL) {
			free(pLibIF->pInstance);
			pLibIF->pInstance = NULL;
		}
		if (pLibIF->hModule != NULL) {
			FreeLibrary(pLibIF->hModule);
			pLibIF->hModule = NULL;
		}
		free(pLibIF);
	}
}

void
ShPhoneLibCtor(
	SHPHONELIBIF* pLibIF,	// IN
	HWND	hWnd			// IN
)
{
	if (pLibIF != NULL) {
		(* pLibIF->pfnCshphonelib_Ctor)(pLibIF->pInstance, hWnd);
	}
}

void
ShPhoneLibDtor(
	SHPHONELIBIF* pLibIF	// IN
)
{
	if (pLibIF != NULL) {
		(* pLibIF->pfnCshphonelib_Dtor)(pLibIF->pInstance);
	}
}

void
ShPhoneLibOnHook(
	SHPHONELIBIF* pLibIF	// IN
)
{
	if (pLibIF != NULL) {
		(* pLibIF->pfnCshphonelib_OnHook)(pLibIF->pInstance);
	}
}