// denwa.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#include "PhoneLibUtil.h"
#include "PhoneStatusUtil.h"

/* Defines */
//#define	PSEUDO_DENWA_MUTEX_NAME				_T("Pseudo Denwa Mutex")
//#define PSEUDO_DENWA_WINDOW_CLASS_NAME		_T("Pseudo Denwa Application Class")
//#define PSEUDO_DENWA_WINDOW_TITLE_NAME		_T("Pseudo Denwa Application Title")
#define PSEUDO_DENWA_WINDOW_CLASS_NAME		_T("AfxFrameOrView80su")
#define PSEUDO_DENWA_WINDOW_TITLE_NAME		_T("db ")

#define PSEUDO_DENWA_SETTING_REGKEY			 _T("Software\\PseudoDenwa")
#define PSEUDO_DENWA_OFFHOOK_PATH			 _T("OffHookKey_cmd")
#define PSEUDO_DENWA_OFFHOOK_ARG			 _T("OffHookKey_arg")
#define PSEUDO_DENWA_ONHOOK_PATH			 _T("OnHookKey_cmd")
#define PSEUDO_DENWA_ONHOOK_ARG				 _T("OnHookKey_arg")

#define WM_SHPHONELIB_EVENT					0x632
#define WPARAM_ONHOOK_EVENT					0x1C2
#define WPARAM_OFFHOOK_EVENT				0x1C3
#define WPARAM_RING_EVENT					0xCA
#define WPARAM_RING_EVENT2					0xD1
#define WPARAM_RING_EVENT3					0xD4

// Global Variables:
HINSTANCE			g_hInst;				// The current instance

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);

static
BOOL
IsKeyLock()
{
	BOOL	bRet = FALSE;
	HKEY	hKey = NULL;

	bRet = FALSE;

	hKey = OpenPhoneStatus();
	if (hKey != NULL) {
		DWORD	dwValue = 0;

		GetPhoneStatus(hKey, 0, &dwValue);

		if (dwValue) {
			// L[bN
			bRet = TRUE;
		}
		else {
			// L[bNԂł͂Ȃ
			bRet = FALSE;
		}

		ClosePhoneStatus(hKey);
		hKey = NULL;
	}

	return bRet;
}

static
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= 0;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= 0;
    wc.hCursor			= 0;
    wc.hbrBackground	= 0;
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= PSEUDO_DENWA_WINDOW_CLASS_NAME;

	return RegisterClass(&wc);
}

static
BOOL
InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd = NULL;

	g_hInst = hInstance;		// Store instance handle in our global variable

	//If it is already running, then focus on the window
	hWnd = FindWindow(PSEUDO_DENWA_WINDOW_CLASS_NAME, PSEUDO_DENWA_WINDOW_TITLE_NAME);	
	if (hWnd) {
#if 0
		int	iRet;

		iRet = MessageBox(NULL, _T("I܂H"), NULL, MB_YESNO|MB_ICONINFORMATION);
		if (iRet == IDYES) {
			PostMessage(hWnd, WM_CLOSE, 0, 0);
		}
#endif
		return FALSE;
	} 

	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	MyRegisterClass(hInstance, PSEUDO_DENWA_WINDOW_CLASS_NAME);
	
	hWnd = CreateWindow(PSEUDO_DENWA_WINDOW_CLASS_NAME, PSEUDO_DENWA_WINDOW_TITLE_NAME, 0,
		0, 0, 0, 0, NULL, NULL, hInstance, NULL);
	if (!hWnd) {
		return FALSE;
	}

	return TRUE;
}


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG	msg;
	
	if (!InitInstance (hInstance, nCmdShow)) {
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

static
void
ExecOffHookAction()
{
	LONG	lResult;
	HKEY	hKey = NULL;

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, PSEUDO_DENWA_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {
		TCHAR	szPath[MAX_PATH+1];
		TCHAR	szArg[MAX_PATH+1];
		DWORD	dwType = 0;
		DWORD	dwSize = 0;

		memset(szPath, 0, sizeof(szPath));
		dwSize = sizeof(szPath);
		lResult = RegQueryValueEx(hKey, PSEUDO_DENWA_OFFHOOK_PATH, NULL, &dwType, (LPBYTE)szPath, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			BOOL				bCreateSucc = FALSE;
			PROCESS_INFORMATION pi;

			memset(&pi, 0, sizeof(pi));

			memset(szArg, 0, sizeof(szArg));
			dwSize = sizeof(szArg);
			lResult = RegQueryValueEx(hKey, PSEUDO_DENWA_OFFHOOK_ARG, NULL, &dwType, (LPBYTE)szArg, &dwSize);
			if (lResult == ERROR_SUCCESS) {
				bCreateSucc = CreateProcess(szPath, szArg, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			}
			else {
				bCreateSucc = CreateProcess(szPath, NULL, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			}

			if (bCreateSucc) {
				CloseHandle(pi.hProcess);
				CloseHandle(pi.hThread);
			}
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}
}

static
void
ExecOnHookAction()
{
	LONG	lResult;
	HKEY	hKey = NULL;

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, PSEUDO_DENWA_SETTING_REGKEY, 0, KEY_ALL_ACCESS, &hKey);

	if (lResult == ERROR_SUCCESS) {
		TCHAR	szPath[MAX_PATH+1];
		TCHAR	szArg[MAX_PATH+1];
		DWORD	dwType = 0;
		DWORD	dwSize = 0;

		memset(szPath, 0, sizeof(szPath));
		dwSize = sizeof(szPath);
		lResult = RegQueryValueEx(hKey, PSEUDO_DENWA_ONHOOK_PATH, NULL, &dwType, (LPBYTE)szPath, &dwSize);
		if (lResult == ERROR_SUCCESS) {
			BOOL				bCreateSucc = FALSE;
			PROCESS_INFORMATION pi;

			memset(&pi, 0, sizeof(pi));

			memset(szArg, 0, sizeof(szArg));
			dwSize = sizeof(szArg);
			lResult = RegQueryValueEx(hKey, PSEUDO_DENWA_ONHOOK_ARG, NULL, &dwType, (LPBYTE)szArg, &dwSize);
			if (lResult == ERROR_SUCCESS) {
				bCreateSucc = CreateProcess(szPath, szArg, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			}
			else {
				bCreateSucc = CreateProcess(szPath, NULL, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
			}

			if (bCreateSucc) {
				CloseHandle(pi.hProcess);
				CloseHandle(pi.hThread);
			}
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}
}

static
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static	SHPHONELIBIF*	s_pPhoneLibIF		= NULL;

	switch (message) 
	{
		case WM_CREATE:

			s_pPhoneLibIF = CreateShPhoneLibIF();

			if (s_pPhoneLibIF != NULL) {
				ShPhoneLibCtor(s_pPhoneLibIF, hWnd);
			}
			break;

		case WM_CLOSE:
			DestroyWindow(hWnd);
			break;

		case WM_DESTROY:
			if (s_pPhoneLibIF != NULL) {
				ShPhoneLibDtor(s_pPhoneLibIF);
				DeleteShPhoneLibIF(s_pPhoneLibIF);
				s_pPhoneLibIF = NULL;
			}
			PostQuitMessage(0);
			break;

		case WM_SHPHONELIB_EVENT:
			switch(wParam) {
				case WPARAM_OFFHOOK_EVENT:
					if (!IsKeyLock()) {
						ExecOffHookAction();
					}
					break;

				case WPARAM_ONHOOK_EVENT:
					if (!IsKeyLock()) {
						ExecOnHookAction();
					}
					break;

				case WPARAM_RING_EVENT:
				case WPARAM_RING_EVENT2:
				case WPARAM_RING_EVENT3:
					ShPhoneLibOnHook(s_pPhoneLibIF);
					break;
			}
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


